
/* Original code:
meter - an LED cpu metering application for Linux machines
Written by Richard Laxton ( u2105546@cumulus.csd.unsw.oz.au )

This program uses the hardware described in the included file "led-stat.txt"
to create a CPU meter that displays on eight LEDs connected to your parallel
port. The code to gather cpu statistics was modified from code written by Mike
Romberg as part of Xosview. Here is the copyright included from that code.

//
//  Copyright (c) 1994 by Mike Romberg (  romberg@md.fsl.noaa.gov )
//
//  This file may be distributed under terms of the GPL
//
*/

//  These functions read from and write to port addresses, using assembly
// language instructions.  They must be run with root privelege, and the 
// function ioperm()  ("i-o permission") must be called firt, or a segmentation
// fault will result.

static inline int port_in( int port )
{
   unsigned char value;
  __asm__ volatile ("inb %1,%0"
                    : "=a" (value)
                    : "d" ((unsigned short)port));
   return value;
}

static inline void port_out( unsigned short int port, unsigned char val )
{
  __asm__ volatile (
                    "outb %0,%1\n"
                    :
                    : "a" (val), "d" (port)
                    );
}

